import time
_marker = []

class StupidCache:

    def __init__(self, max_size=1000, max_age=3600):
        self.max_size = max_size
        self.max_age = max_age
        self.cache = {}
        
    def set(self, key, value):
        # cache is about to be full - blow it away
        if len(self.cache) > self.max_size-2:
            self.clear()
        self.cache[key] = (value, time.time())

    def get(self, key, default):
        v,t = self.cache.get(key, (_marker, None))
        if v is _marker:
            return default
        if t and time.time()-t > self.max_age:
            del self.cache[key]
            return default
        return v

    def clear(self):
        self.cache = {}
